import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse3",
    fullName: "Extinction Curse - Life's Long Shadows",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: LIFE’S LONG SHADOWS' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumnWithLeftCutout(8, 210),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumnWithMap(10, 340),
        new EC.RightTwoColumn(11),
        new EC.LeftTwoColumn(12),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumn(14),
        new EC.RightTwoColumn(15),
        new EC.LeftTwoColumn(16),
        new EC.RightTwoColumn(17),
        new EC.LeftTwoColumn(18),
        new EC.RightTwoColumn(19),
        new EC.LeftTwoColumn(20),
        new EC.RightTwoColumn(21),
        new EC.LeftTwoColumn(22),
        new EC.RightTwoColumn(23),

        // chapter 2
        new EC.ChapterHeadingPageLayout(24),
        new EC.RightSingleColumnWithSidebar(25),
        new EC.LeftTwoColumnWithLeftCutout(26, 305),
        new EC.RightTwoColumn(27),
        new EC.LeftTwoColumnWithMap(28, 340),
        new EC.RightTwoColumn(29),
        new EC.LeftTwoColumn(30),
        new EC.RightTwoColumn(31),
        new EC.LeftTwoColumn(32),
        new EC.RightTwoColumn(33),

        // chapter 3
        new EC.ChapterHeadingPageLayout(34),
        new EC.RightSingleColumnWithSidebar(35),
        new EC.LeftTwoColumn(36),
        new EC.RightTwoColumnWithRightCutout(37, 305),
        new EC.LeftTwoColumnWithMap(38, 340),
        new EC.RightTwoColumn(39),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),

        // chapter 4
        new EC.ChapterHeadingPageLayout(42),
        new EC.RightSingleColumnWithSidebar(43),
        new EC.LeftTwoColumnWithLeftCutout(44, 210),
        new EC.RightTwoColumn(45),
        new EC.LeftTwoColumn(46),
        new EC.RightTwoColumn(47),
        new EC.LeftTwoColumnWithMap(48, 340),
        new EC.RightTwoColumn(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumn(52),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumn(54),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),

        // appendix 1
        new EC.RightChapterHeadingPageLayout(59),
        new EC.LeftTwoColumnWithMap(60, 340),
        new EC.RightTwoColumn(61),
        new EC.LeftTwoColumnWithLeftCutout(62, 460),
        new EC.RightTwoColumn(63),

        // appendix 2
        new EC.RightChapterHeadingPageLayout(65),
        new EC.LeftTwoColumn(66),
        new EC.RightTwoColumn(67),
        new EC.LeftTwoColumn(68),
        new EC.RightTwoColumn(69),
        
        // adventure toolbox
        new EC.RightChapterHeadingPageLayout(71),
        new EC.LeftTwoColumn(72),
        new EC.RightTwoColumn(73),
        new EC.LeftSingleColumnWithSidebar(74),
        new EC.RightTwoColumn(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftSingleColumnWithSidebar(78),
        new EC.RightSingleColumnWithSidebar(79),
        new EC.LeftSingleColumnWithSidebar(80),
        new EC.RightSingleColumnWithSidebar(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),
        new EC.RightSingleColumnWithSidebar(85),
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.ChapterHeadingPageLayout(88),
        new EC.RightTwoColumn(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightSingleColumnWithSidebar(93),
    ],
    scenes: [
        new ModuleScene({
            name: 'map1',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 10, width: 1262, height: 880,
            imageLeft: 24, imageRight: 1249, imageCols: 34,
            imageTop: 36, imageBottom: 870, imageRows: 22,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 75, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 27, width: 516, height: 656,
            imageLeft: 11, imageRight: 500, imageCols: 15,
            imageTop: 28, imageBottom: 644, imageRows: 19,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 28, width: 1262, height: 880,
            imageLeft: 12, imageRight: 1250, imageCols: 34,
            imageTop: 24, imageBottom: 861, imageRows: 23,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 106.5, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 36, width: 516, height: 658,
            imageLeft: 6, imageRight: 512, imageCols: 36,
            imageTop: 13, imageBottom: 644, imageRows: 45,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 38, width: 1262, height: 880,
            imageLeft: 14, imageRight: 1242, imageCols: 68,
            imageTop: 5, imageBottom: 876, imageRows: 49,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map6',
            nameInfo: { x: 106.5, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 46, width: 516, height: 655,
            imageLeft: 15, imageRight: 509, imageCols: 35,
            imageTop: 25, imageBottom: 648, imageRows: 44,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map7',
            nameInfo: { x: 106.5, y: 373.5456 },
            nameFn: name => sentenceCase(name),
            page: 46, width: 516, height: 658,
            imageLeft: 3, imageRight: 486, imageCols: 17,
            imageTop: 8, imageBottom: 632, imageRows: 22,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map8',
            nameInfo: { x: 23.25, y: 760.0862 },
            nameFn: name => sentenceCase(name),
            page: 48, width: 636, height: 880,
            imageLeft: 17, imageRight: 631, imageCols: 36,
            imageTop: 10, imageBottom: 863, imageRows: 50,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map9',
            nameInfo: { x: 317.25, y: 747 },
            nameFn: name => sentenceCase(name),
            page: 48, width: 647, height: 880,
            imageLeft: 14, imageRight: 627, imageCols: 36,
            imageTop: 10, imageBottom: 863, imageRows: 50,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map10',
            nameInfo: { x: 16, y: 755.4952 },
            nameFn: name => sentenceCase(name),
            page: 60, width: 1262, height: 880,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal7', page: 4, width: 1262, height: 1636 }),
        new AdventureImage({ name: 'journal8', page: 6, width: 1261, height: 805 }),
        new CaptionImage({ name: 'journal9', page: 12, width: 462, height: 462 }),
        new CaptionImage({ name: 'journal10', page: 14, width: 682, height: 570 }),
        new AdventureImage({ name: 'journal11', page: 24, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal12', page: 34, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal13', page: 42, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal14', page: 58, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal15', page: 64, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal16', page: 70, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal17', page: 71, width: 433, height: 500 }),
        new AdventureImage({ name: 'journal18', page: 72, width: 942, height: 1131 }),
        new AdventureImage({ name: 'journal19', page: 75, width: 736, height: 1123 }),
        new AdventureImage({ name: 'journal20', page: 76, width: 692, height: 1090 }),
        new AdventureImage({ name: 'journal21', page: 77, width: 799, height: 1015 }),

        new CaptionImage({ name: 'npc1', page: 9, width: 856, height: 1079 }),
        new CaptionImage({ name: 'npc2', page: 16, width: 573, height: 572 }),
        new CaptionImage({ name: 'npc3', page: 17, width: 573, height: 573 }),
        new CaptionImage({ name: 'npc4', page: 18, width: 407, height: 844 }),
        new CaptionImage({ name: 'npc5', page: 19, width: 717, height: 1261 }),
        new CaptionImage({ name: 'npc6', page: 20, width: 853, height: 1178 }),
        new CaptionImage({ name: 'npc7', page: 22, width: 773, height: 1035 }),
        new CaptionImage({ name: 'npc8', page: 29, width: 812, height: 1187 }),
        new CaptionImage({ name: 'npc9', page: 30, width: 809, height: 1201 }),
        new CaptionImage({ name: 'npc10', page: 33, width: 759, height: 1269 }),
        new CaptionImage({ name: 'npc11', page: 39, width: 761, height: 1096 }),
        new CaptionImage({ name: 'npc12', page: 40, width: 853, height: 1054 }),
        new CaptionImage({ name: 'npc13', page: 41, width: 696, height: 1099 }),
        new CaptionImage({ name: 'npc14', page: 43, width: 573, height: 573 }),
        new CaptionImage({ name: 'npc15', page: 45, width: 848, height: 1187 }),
        new CaptionImage({ name: 'npc16', page: 47, width: 573, height: 573 }),
        new CaptionImage({ name: 'npc17', page: 52, width: 932, height: 1201 }),
        new CaptionImage({ name: 'npc18', page: 54, width: 872, height: 950 }),
        new CaptionImage({ name: 'npc19', page: 57, width: 865, height: 1132 }),
        new CaptionImage({ name: 'npc20', page: 63, width: 805, height: 1134 }),
        new CaptionImage({ name: 'npc21', page: 67, width: 853, height: 1128 }),
        new CaptionImage({ name: 'npc22', page: 78, width: 732, height: 1165 }),
        new CaptionImage({ name: 'npc23', page: 79, width: 767, height: 1287 }),
        new CaptionImage({ name: 'npc24', page: 80, width: 820, height: 854 }),
        new CaptionImage({ name: 'npc25', page: 81, width: 851, height: 1001 }),
        new CaptionImage({ name: 'npc26', page: 83, width: 709, height: 1153 }),
        new CaptionImage({ name: 'npc27', page: 84, width: 821, height: 1048 }),
        new CaptionImage({ name: 'npc28', page: 85, width: 797, height: 1235 }),
        new CaptionImage({ name: 'npc29', page: 86, width: 843, height: 1187 }),
        new CaptionImage({ name: 'npc30', page: 87, width: 740, height: 1185 }),
        new CaptionImage({ name: 'npc31', page: 89, width: 709, height: 937 }),
        new CaptionImage({ name: 'npc32', page: 91, width: 812, height: 1121 }),
        new CaptionImage({ name: 'npc33', page: 93, width: 978, height: 1125 }),

    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;